Get Some Topology Information

## Enumerations

enum | hwloc_get_type_depth_e { HWLOC_TYPE_DEPTH_UNKNOWN, HWLOC_TYPE_DEPTH_MULTIPLE, HWLOC_TYPE_DEPTH_BRIDGE, HWLOC_TYPE_DEPTH_PCI_DEVICE, HWLOC_TYPE_DEPTH_OS_DEVICE }

## Functions

unsigned | hwloc_topology_get_depth (hwloc_topology_t restrict topology)
int | hwloc_get_type_depth (hwloc_topology_t topology, hwloc_obj_type_t type)
hwloc_obj_type_t | hwloc_get_depth_type (hwloc_topology_t topology, unsigned depth)
unsigned | hwloc_get_nbobjs_by_depth (hwloc_topology_t topology, unsigned depth)
static inline int | hwloc_get_nbobjs_by_type (hwloc_topology_t topology, hwloc_obj_type_t type)
int | hwloc_topology_is_thissystem (hwloc_topology_t restrict topology)
unsigned long | hwloc_topology_get_flags (hwloc_topology_t topology)

## Detailed Description

Be sure to see the figure in termsanddefs that shows a complete topology tree, including depths, child/sibling/cousin relationships, and an example of an asymmetric topology where one socket has fewer caches than its peers.

## Enumeration Type Documentation

enum hwloc_get_type_depth_e

Enumerator
HWLOC_TYPE_DEPTH_UNKNOWN | No object of given type exists in the topology.
HWLOC_TYPE_DEPTH_MULTIPLE | Objects of given type exist at different depth in the topology.
HWLOC_TYPE_DEPTH_BRIDGE | Virtual depth for bridge object level.
HWLOC_TYPE_DEPTH_PCI_DEVICE | Virtual depth for PCI device object level.
HWLOC_TYPE_DEPTH_OS_DEVICE | Virtual depth for software device object level.

## Function Documentation

hwloc_obj_type_t hwloc_get_depth_type | ( | hwloc_topology_t | topology,
|  | unsigned | depth
| ) |  |

Returns the type of objects at depth `depth`.

Returns
  -1 if depth `depth` does not exist.

unsigned hwloc_get_nbobjs_by_depth | ( | hwloc_topology_t | topology,
|  | unsigned | depth
| ) |  |

Returns the width of level at depth `depth`.

static inline int hwloc_get_nbobjs_by_type | ( | hwloc_topology_t | topology,
|  | hwloc_obj_type_t | type
| ) |  |

static

Returns the width of level type `type`.

If no object for that type exists, 0 is returned. If there are several levels with objects of that type, -1 is returned.

int hwloc_get_type_depth | ( | hwloc_topology_t | topology,
|  | hwloc_obj_type_t | type
| ) |  |

Returns the depth of objects of type `type`.

If no object of this type is present on the underlying architecture, or if the OS doesn't provide this kind of information, the function returns HWLOC_TYPE_DEPTH_UNKNOWN.

If type is absent but a similar type is acceptable, see also hwloc_get_type_or_below_depth() and hwloc_get_type_or_above_depth().

If some objects of the given type exist in different levels, for instance L1 and L2 caches, or L1i and L1d caches, the function returns HWLOC_TYPE_DEPTH_MULTIPLE. See hwloc_get_cache_type_depth() in hwloc/helper.h to better handle this case.

If an I/O object type is given, the function returns a virtual value because I/O objects are stored in special levels that are not CPU-related. This virtual depth may be passed to other hwloc functions such as hwloc_get_obj_by_depth() but it should not be considered as an actual depth by the application. In particular, it should not be compared with any other object depth or with the entire topology depth.

unsigned hwloc_topology_get_depth | ( | hwloc_topology_t restrict | topology) |  |

Get the depth of the hierarchical tree of objects.

This is the depth of HWLOC_OBJ_PU objects plus one.

unsigned long hwloc_topology_get_flags | ( | hwloc_topology_t | topology) |  |

Get OR'ed flags of a topology.

Get the OR'ed set of hwloc_topology_flags_e of a topology.

Returns
  the flags previously set with hwloc_topology_set_flags().

int hwloc_topology_is_thissystem | ( | hwloc_topology_t restrict | topology) |  |

Does the topology context come from this system?

Returns
  1 if this topology context was built using the system running this program.
  0 instead (for instance if using another file-system root, a XML topology file, or a synthetic topology).